﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace EntitySampleSumming.Controllers
{
    public class HomeController : Controller
    {
        //
        // GET: /Home/
        public ActionResult Index(string monthSeleted)
        {
            if (monthSeleted == null)
            {
                monthSeleted = "1";
            }
            List<EmployeeTimeSheet> EmployeeTimeSheetObj = new List<EmployeeTimeSheet>();

            using (EntityFrameworkBlogEntities db = new EntityFrameworkBlogEntities())
            {
                EmployeeTimeSheetObj = (from emp in db.EmployeeTimeSheets
                                        select emp).ToList();
                EmployeeTimeSheetObj = EmployeeTimeSheetObj.Where(e => Convert.ToDateTime(e.Date).Month == Convert.ToInt64(monthSeleted)).ToList()
                    .GroupBy(o => new { o.EmpId, o.Name }).Select(g => new EmployeeTimeSheet
                    {
                        EmpId = g.Key.EmpId,
                        Name = g.Key.Name,
                        ProjectName = String.Join(",", g.Select(i => i.ProjectName).Distinct()),
                        TotalWorkingHrs = (g.Sum(x => Convert.ToDecimal(x.TotalWorkingHrs.Substring(0, 2))) + Convert.ToInt64(g.Sum(y => Convert.ToDecimal(y.TotalWorkingHrs.Substring(3, 2)))) / 60
                        + (g.Sum(z => Convert.ToDecimal(z.TotalWorkingHrs.Substring(3, 2))) % 60) * Convert.ToDecimal(0.01)).ToString().Replace('.', ':')
                    }).ToList();
            }

            return View(EmployeeTimeSheetObj);
        }

        public ActionResult GetEmployeeDetails(int EmpId, int month)
        {
            List<EmployeeTimeSheet> employeeTimeSheetObj = new List<EmployeeTimeSheet>();
            using (EntityFrameworkBlogEntities db = new EntityFrameworkBlogEntities())
            {
                employeeTimeSheetObj = (from time in db.EmployeeTimeSheets
                                        where time.EmpId == EmpId
                                        select time).ToList();
                employeeTimeSheetObj = employeeTimeSheetObj.Where(x => Convert.ToDateTime(x.Date).Month == month).ToList();
            }
            return View(employeeTimeSheetObj);
        }
    }
}
